#pragma once
using namespace std;

class NeuronNetwork {
public:
  double learningRate;

	NeuronNetwork(int inputNodeCount, int hiddenNodeCount, int outputNodeCount);
  NeuronNetwork(ifstream* input);
	
	void evaluate(Matrix* input, Matrix* output);
	void learn(Matrix* input, Matrix* target);

	void save(ofstream* output);

  ~NeuronNetwork();
protected:
	Matrix* hiddenLayerWeights;
	Matrix* outputLayerWeights;

  Matrix hiddenActivation;
  Matrix outputActivation;

  Matrix hiddenError;
  Matrix outputError;

  Matrix tempMatrix;
};
